#ifndef LiquidCrystal_h
#define LiquidCrystal_h

#include "stm32f4xx_hal.h"

#ifndef BOOTLOADER
#define LCDACTION_BUFFER_SIZE 128
#else
#define LCDACTION_BUFFER_SIZE 1
#endif

// commands
#define LCD_CLEARDISPLAY 0x01
#define LCD_RETURNHOME 0x02
#define LCD_ENTRYMODESET 0x04
#define LCD_DISPLAYCONTROL 0x08
#define LCD_CURSORSHIFT 0x10
#define LCD_FUNCTIONSET 0x20
#define LCD_SETCGRAMADDR 0x40
#define LCD_SETDDRAMADDR 0x80

// flags for display entry mode
#define LCD_ENTRYRIGHT 0x00
#define LCD_ENTRYLEFT 0x02
#define LCD_ENTRYSHIFTINCREMENT 0x01
#define LCD_ENTRYSHIFTDECREMENT 0x00

// flags for display on/off control
#define LCD_DISPLAYON 0x04
#define LCD_DISPLAYOFF 0x00
#define LCD_CURSORON 0x02
#define LCD_CURSOROFF 0x00
#define LCD_BLINKON 0x01
#define LCD_BLINKOFF 0x00

// flags for display/cursor shift
#define LCD_DISPLAYMOVE 0x08
#define LCD_CURSORMOVE 0x00
#define LCD_MOVERIGHT 0x04
#define LCD_MOVELEFT 0x00

// flags for function set
#define LCD_8BITMODE 0x10
#define LCD_4BITMODE 0x00
#define LCD_2LINE 0x08
#define LCD_1LINE 0x00
#define LCD_5x10DOTS 0x04
#define LCD_5x8DOTS 0x00

struct pin
{
  GPIO_TypeDef *gpio;
  unsigned char pinNumber;
};

void          LiquidCrystal_begin( unsigned char cols, unsigned char lines );
void          LiquidCrystal_createChar( unsigned char, unsigned char[] );
void          LiquidCrystal_setCursor( unsigned char, unsigned char );
void          LiquidCrystal_clear(  );
void          LiquidCrystal_home(  );
void          LiquidCrystal_noDisplay(  );
void          LiquidCrystal_display(  );
void          LiquidCrystal_noBlink(  );
void          LiquidCrystal_blink(  );
void          LiquidCrystal_noCursor(  );
void          LiquidCrystal_cursor(  );
void          LiquidCrystal_scrollDisplayLeft(  );
void          LiquidCrystal_scrollDisplayRight(  );
void          LiquidCrystal_leftToRight(  );
void          LiquidCrystal_rightToLeft(  );
void          LiquidCrystal_autoscroll(  );
void          LiquidCrystal_noAutoscroll(  );
void          LCD_char( unsigned char col, unsigned char row, unsigned char ch );
int           LCD_print( unsigned char col, unsigned char row, char *fmt, ... );
#endif
