#include <stdio.h>
#include <stdlib.h>

#define SAMPLE_RATE 48000

#define TARGET ( SAMPLE_RATE * 32 * 2 ) // 32 bit, stereo

int
main( int argc, char *argv[] )
{
  float freq;
  long long div, err;
  int           i, j, min;
  int           ki, kj, kdiv;

  ki =  kj = kdiv = 0;
  min = 50000;
  for( i = 2; i <= 509; i++ )
    for( j = 2; j < 8; j++ )
    {
      div = (long long )TARGET * i * j / 1000000LL;
      if( div < 52 || div > 432 )
	continue;
      err = (long long )TARGET * i * j - 1000000LL * div;
      if( err < 0LL )
	err = -err;
      if( err > 50000LL )
	continue;
      printf( "error %lld N %lld R %d I2SDiv %d \n", err, div, j, i );
      if( err < min )
      {
	min = err;
	ki = i;
	kj = j;
	kdiv = div;
      }
    }
  freq = 1e6 / 32 / 2 * kdiv / kj / ki;
  printf( "\nFrequency %.3f error %.4f%% N %d R %d I2SDiv %d \n", 
      freq, 100. * (freq - SAMPLE_RATE ) / SAMPLE_RATE, kdiv, kj, ki );
  return 1;
}
